﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Optimization;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Encodings.SchedulingEncoding.Encodings;
using HeuristicLab.Encodings.SchedulingEncoding.Interfaces;

namespace HeuristicLab.Encodings.SchedulingEncoding.PermutationWithRepetition.Manipulators {
  [Item("PWRManipulator", "An operator which manipulates a PWR representation.")]
  [StorableClass]
  public abstract class PWRManipulator : SchedulingManipulator<PWREncoding>, IPWROperator {
    [StorableConstructor]
    protected PWRManipulator(bool deserializing) : base(deserializing) { }
    protected PWRManipulator(PWRManipulator original, Cloner cloner) : base(original, cloner) { }
    public PWRManipulator()
      : base() {
    }

    protected abstract PWREncoding Manipulate(IRandom random, PWREncoding individual);


    public override IOperation Apply() {
      PWREncoding solution = SchedulingSolutionParameter.ActualValue;

      SchedulingSolutionParameter.ActualValue = Manipulate(RandomParameter.ActualValue, solution as PWREncoding);

      return base.Apply();
    }

  }
}
