﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Drawing;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Scheduling.Evaluators {
  [Item("SchedulingEvaluatorType", "Represents a certain type of scheduling evaluator.")]
  [StorableClass]
  public class SchedulingEvaluatorType : ValueTypeValue<SchedulingEvaluatorTypes> {
    [StorableConstructor]
    protected SchedulingEvaluatorType(bool deserializing) : base(deserializing) { }
    protected SchedulingEvaluatorType(SchedulingEvaluatorType original, Cloner cloner) : base(original, cloner) { }
    public SchedulingEvaluatorType() : base() { }
    public SchedulingEvaluatorType(SchedulingEvaluatorTypes type) : base(type) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new SchedulingEvaluatorType(this, cloner);
    }
  }
}
